import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsCoursepoint {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  CourseId!: IType<number, bigint>;
  Content?: string;
  TimePoint!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsCoursepointSchema = defineEntity({
  class: ScsCoursepoint,
  comment: '课程知识点',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    CourseId: p.bigint().name('CourseId').columnType('bigint').comment('课程id'),
    Content: p.string().name('Content').length(500).nullable().comment('内容'),
    TimePoint: p.integer().name('TimePoint').comment('时间点'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
